define([ "dojo/_base/declare",
   "dojo/when",
   "aps/View" ],
function(declare, when, View) {

   var vpsData = { vps:{} }; // Global structure with VPS properties

   return declare(View, {

		/* Widget initialization */
		init: function() {
			return ["aps/Panel", {
					id: this.genId("vps-aw-panel"),
					title: "My VPS for Activation"
				},
				[
					["aps/FieldSet", {
					id: this.genId("vps-aw-fieldset"),
					title: "My VPS",
					gridSize: "md-12 xs-12"
					}, [
					["aps/Output", {
						id: this.genId("user-aw-name"),
						label: 'User Name'
					}],
					["aps/TextBox",{
						id: this.genId("vps-aw-textbox"),
						autoSize: false,
						label: 'VPS Name',
						required: true
					}]
				]]]
			];
		},   // End of Init

		/* Auxiliary function to draw widgets with actual VPS properties*/
		_drawPanel: function (vps) {
			vpsData.vps = vps;
			this.byId("user-aw-name").set("value", aps.context.user.displayName);
			this.byId("vps-aw-textbox").set("value", vps.name);
		},

		/* Data initialization */
		onContext: function(context) {
			var vps = context.vars.endusers.find(function(vps) {
				return vps.user.userId === aps.context.user.userId;
			});
			if (vps) {
				this._drawPanel(vps);
			}
			aps.apsc.hideLoading();
		},

		/* Handler for the Activate button */
		onNext: function () {
		   vpsData.vps.name = this.byId("vps-aw-textbox").value;
		   var savedXhr = {
		      url: '/aps/2/resources/' + vpsData.vps.aps.id + '/activate',
		      method: 'PUT',
		      headers: {
		         "Content-Type": 'application/json'
		      },
		      data: JSON.stringify(vpsData.vps)
		   };
		   aps.apsc.next({objects: [{ xhr: savedXhr }]});
		}
   });      // End of Declare
});         // End of Define